#include <bits/stdc++.h>

using namespace std;

float calcA(int x1, int x2) {
    return (1.0 / float(x2 - x1));
}

bool check(float x, float y, int x_min, int x_max) {
    if (y < 1 || y > 2) {
        return false;
    }

    if (x < x_min || x > x_max) {
        return false;
    }

    return true;
}

int bfs(list<int> adj[], int n) {
    int x, res = 0, s;
    queue<int> q;
    vector<bool> visited(n, 0);

    vector<bool>::iterator it = find(visited.begin(), visited.end(), 0);

    while (it != visited.end()) {
        s = distance(visited.begin(), it);
        q.push(s);
        visited[s] = true;

        while (!q.empty()) {
            x = q.front();
            q.pop();

            for (list<int>::iterator it = adj[x].begin(); it != adj[x].end(); ++it) {
                if (!visited[*it]) {
                    visited[*it] = true;
                    q.push(*it);
                }
            }
        }

        ++res;
        it = find(visited.begin(), visited.end(), 0);
    }

    return res;
}

int main()
{
    ios_base::sync_with_stdio(false); cin.tie(NULL);

    int n, x_min, x_max;
    float a1, a2, x_cross, y_cross;
    cin >> n;

    bool flag;

    int x1[n], x2[n];
    list<int> adj[n];

    for (int i = 0; i < n; ++i) {
        cin >> x1[i];
    }

    for (int i = 0; i < n; ++i) {
        cin >> x2[i];
    }

    for (int i = 0; i < n - 1; ++i) {
        if (x1[i] == x2[i]) {
            continue;
        } else {
            a1 = calcA(x1[i], x2[i]);
        }

        for (int j = i + 1; j < n; ++j) {
            a2 = calcA(x1[j], x2[j]);

            x_cross = (a1 * x1[i] - a2 * x1[j]) / (a1 - a2);
            y_cross = a1 * (x_cross - x1[i]) + 1;

            x_min = min(min(x1[i], x2[i]), min(x1[j], x2[j]));
            x_max = max(max(x1[i], x2[i]), max(x1[j], x2[j]));

            flag = check(x_cross, y_cross, x_min, x_max);

            if (flag) {
                adj[i].push_back(j);
                adj[j].push_back(i);
            }
        }
    }

    cout << bfs(adj, n);
}