#include <bits/stdc++.h>

using namespace std;

const int mxN = 3e5 + 12;
int dsu[mxN];
int vel[mxN];

int findSet(int u) {
    if(u == dsu[u])
        return u;
    return dsu[u] = findSet(dsu[u]);
}

void unite(int u, int v) {
    u = findSet(u);
    v = findSet(v);
    if(u == v)
        return;
    if(vel[u] > vel[v])
        swap(u, v);
    dsu[u] = v;
    vel[v] += vel[u];
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for(auto &z : a) cin >> z;
    for(auto &z : b) cin >> z;

    for(int i = 0; i < n; ++i) {
        dsu[i] = i;
        vel[i] = 1;
    }

    for(int i = 0; i < n; ++i) {
        for(int j = i+1; j < n; ++j) {
            int izraz = -(b[j] - b[i]);
            int izraz2 = a[j] - a[i];
            if(izraz > 0 && izraz2 > 0) {
                unite(i, j);
            } else if(izraz < 0 && izraz2 < 0) {
                unite(i, j);
            }
        }
    }

    int ans = 0;
    for(int i = 0; i < n; ++i) {
        ans += (findSet(i) == i);
    }
    cout << ans;
}