#include <iostream>
#include <vector>
#include <algorithm>
#include <functional>

using namespace std;

int components(vector<vector<int>> g){
    vector<bool> visited(g.size(), false);

    function<void(int)> dfs = [&dfs, &g, &visited](int i)->void{
        visited[i]=true;
        for(int j = 0;j<g[i].size();j++){
            if(!visited[g[i][j]]){
                dfs(g[i][j]);
            }
        }
    };

    int components=0;
    for(int i = 0; i < g.size(); i++){
        if(!visited[i]){
            components++;
            dfs(i);
        }
    }
    return components;
}

pair<vector<int>, vector<int>> read(){
    int n;
    cin >> n;
    vector<int> a;
    for(int i=0;i<n;i++){
        int t;
        cin >> t;
        a.push_back(t);
    }
    vector<int> b;
    for(int i=0;i<n;i++){
        int t;
        cin >> t;
        b.push_back(t);
    }
    return make_pair(a,b);

    /*vector<int> x, y;
    for(int i=0;i<n;i++)
        x[i]=y[i]=i;
    sort(
         x.begin(),
         x.end(),
         [&a](int p, int q)->int{
            return a[p]-a[q];
         }
    );
    sort(
         y.begin(),
         y.end(),
         [&b](int p, int q)->int{
            return b[q]-b[p];
         }
    );
    return make_pair(x,y);*/
}

vector<vector<int>> get_graph(pair<vector<int>, vector<int>> t){
    vector<vector<int>> g;
    for(int i = 0;i<t.first.size();i++){
        vector<int> a;
        for(int j = 0;j<i;j++){
            bool p = t.first[i]<t.first[j];
            bool q = t.second[i]<t.second[j];
            if(p ^ q){
                a.push_back(j);
                g[j].push_back(i);
            }
        }
        g.push_back(a);
    }
    return g;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    auto t = read();

    cout << components(get_graph(t));

    return 0;
}