#include <cstdio>
#include <cstdint>
#include <cstring>
#include <algorithm>

#define MAX_N 1000000
#define MAX_M 100
#define MAX_RATIO MAX_N

uint32_t n, m;
uint32_t value;
uint32_t arr[MAX_N];
uint32_t sums[MAX_N];
uint32_t limits[MAX_N];
uint32_t cursors[MAX_M * MAX_M / 2];
uint32_t sum;

int main()
{
    scanf("%u%u", &n, &m);

    sum = 0;
    for (int i = 0; i < n; ++i)
    {
        scanf("%u", &value);
        uint32_t* bound = std::upper_bound(arr, arr + i, value);
        memmove(bound + 1, bound, (i - (bound - arr)) * sizeof(uint32_t));
        *bound = value;
    }

    for (int i = 0; i < n; ++i)
    {
        sum += arr[i];
        sums[i] = sum;
    }

    for (uint32_t i = 0; i * m < n; ++i)
        limits[i] = sums[n % m + i * m - 1];

    uint32_t excludeLevel = 0;
    uint32_t excluded;
    uint32_t cursorOffset;
    uint32_t excludedSum = 0;
    while (true)
    {
        while(limits[excludeLevel] > limits[excludeLevel + 1])
            ++excludeLevel;
        excluded = n % m + excludeLevel * m;

        cursorOffset = n % m * excludeLevel + m * excludeLevel * (excludeLevel - 1) / 2 ;

        excludedSum = 0;
        for (uint32_t i = 0; i < n % m + m * excludeLevel; ++i)
            excludedSum += arr[cursors[cursorOffset + i]];

        if ((sum - excludedSum) % m == 0)
            break;

        //Advance cursor
        uint32_t i = 0;
        for (; cursors[cursorOffset + i] + 1 == cursors[cursorOffset + i + 1] && i != excludeLevel; ++i)
            cursors[cursorOffset + i] = i;
        ++cursors[cursorOffset + i];

        limits[excludeLevel] = excludedSum;
    }

    printf("%u", sum - excludedSum);
    return 0;
}

/*
10 3
100 90 80 70 60 50 40 30 20 10
*/