#include <bits/stdc++.h>
using namespace std;
#define INF (long long)1e18
#define MOD (long long)(1e9 + 7)
#define endl '\n'
#define K int(1e3 + 1)
#define X real()
#define Y imag()
#define EPS 1e-6
#define PI 3.141592
#define cross(a, b) (conj(a) * b).Y;
#define MAN(a, b) norm(a, b)
#define EUC(a, b) abs(a, b)
typedef long long ll;
typedef unsigned int ui;
typedef unsigned long long ull;
typedef unsigned short us;
typedef complex<double> point;

struct seg{
    int a, b, i;
};

bool cmp(seg a, seg b){
    return a.a < b.a;
}

void dfs(int i, vector<vector<int>> &adj, vector<bool> &vis){
    if (vis[i]) return;
    vis[i] = 1;
    for (int i : adj[i])
        dfs(i, adj, vis);
}

vector<seg> merge_sort(vector<seg> &s, vector<vector<int>> &adj, int lb, int rb){
    if (lb == rb){
        vector<seg> a(1, s[lb]);
        return a;
    }
    int m = (lb + rb) / 2;
    vector<seg> l = merge_sort(s, adj, lb, m),
                r = merge_sort(s, adj, m + 1, rb), ret;
    int i = 0, j = 0;
    while (i < l.size() && j < r.size()){
        if (l[i].a > r[j].a) swap(l[i], r[j]);
        if (l[i].b > r[j].b){
            adj[l[i].i].push_back(r[j].i),
            adj[r[j].i].push_back(l[i].i);
            ret.push_back(l[i]);
            ++i;
        }
        else ret.push_back(r[j++]);
    }
    while (i < l.size()) ret.push_back(l[i++]);
    while (j < r.size()) ret.push_back(r[j++]);
    return ret;
}

void solve(){
    int n; cin >> n;
    vector<int> a(n), b(n);
    for (int &i : a) cin >> i;
    for (int &i : b) cin >> i;
    vector<seg> s(n);
    for (int i = 0; i < n; i++)
        s[i] = {a[i], b[i], i};
    sort(s.begin(), s.end(), cmp);
    vector<vector<int>> adj(n);
    merge_sort(s, adj, 0, n - 1);
    int ans = 0;
    vector<bool> vis(n, 0);
    for (int i = 0; i < n; i++)
        if (!vis[i]) { ++ans, dfs(i, adj, vis); }
    cout << ans << endl;
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int t = 1; // cin >> t;
    while (t--) solve();

    return 0;
}