#include <bits/stdc++.h>
using namespace std;

const int N = 300005;

vector<vector<int>> mat;
int st[4 * N][2];
int inv[N][2]; //inv[i][0] = 1 ako a[i] < a[i + 1], inv[i][1] = 1 - inv[i][0];
int n, m, q;
int one = -1;


void build(int id, int l, int r){
    if(l == r){
        st[id][0] = inv[l][0];
        st[id][1] = inv[l][1];
        return;
    }

    int mid = (l + r) / 2;
    build(id * 2 + 1, l, mid);
    build(id * 2 + 2, mid + 1, r);
    st[id][0] = st[id * 2 + 1][0] + st[id * 2 + 2][0];
    st[id][1] = st[id * 2 + 1][1] + st[id * 2 + 2][1];
}

int getSum(int x, int y, int t, int id, int l, int r){
    if(l > y || r < x)
        return 0;
    if(x <= l && r <= y){
        return st[id][t];
    }

    int mid = (l + r) / 2;
    int v1 = getSum(x, y, t, id * 2 + 1, l, mid);
    int v2 = getSum(x, y, t, id * 2 + 2, mid + 1, r);
    return v1 + v2;
}

void update(int x, int id, int l, int r){ //type 0, auto for type 1
    if(l > x || r < x)
        return;
    if(l == r){
        st[id][0] = inv[l][0];
        st[id][1] = 1 - st[id][0];
        return;
    }

    int mid = (l + r) / 2;
    update(x, id * 2 + 1, l, mid);
    update(x, id * 2 + 2, mid + 1, r);
    st[id][0] = st[id * 2 + 1][0] + st[id * 2 + 2][0];
    st[id][1] = st[id * 2 + 1][1] + st[id * 2 + 2][1];
}

int a[N];

void updateQuery(int x, int y){
    if(x > 0){
        inv[x - 1][0] = a[x - 1] < a[x];
        inv[x - 1][1] = 1 - inv[x - 1][0];
        update(x - 1, 0, 0, m - 2);
    }
    if(x < m - 1){
        inv[x][0] = a[x] < a[x + 1];
        inv[x][1] = 1 - inv[x][0];
        update(x, 0, 0, m - 2);
    }
    if(y > 0){
        inv[y - 1][0] = a[y - 1] < a[y];
        inv[y - 1][1] = 1 - inv[y - 1][0];
        update(y - 1, 0, 0, m - 2);
    }
    if(y < m - 1){
        inv[y][0] = a[y] < a[y + 1];
        inv[y][1] = 1 - inv[y][0];
        update(y, 0, 0, m - 2);
    }

    if(a[x] == 1)
        one = x;
    if(a[y] == 1)
        one = y;
}

void getQuery(){
    if(one == 0){
        int v = getSum(0, m - 2, 0, 0, 0, m - 2);
        cout << (v == m - 1 ? "DA\n" : "NE\n");
    }else if(one == m - 1){
        int v = getSum(0, m - 2, 1, 0, 0, m - 2);
        cout << (v == m - 1 ? "DA\n" : "NE\n");
    }else{
        int v1 = getSum(0, one - 1, 1, 0, 0, m - 2);
        int v2 = getSum(one, m - 2, 0, 0, 0, m - 2);
        cout << (v1 + v2 == m - 1 ? "DA\n" : "NE\n");
    }
}

void bruteforce(){
    bool ok = true;
    for(int i = one; i < m - 1; ++i){
        if(a[i] > a[i + 1]){
            ok = false;
            break;
        }
    }
    for(int i = 0; i < one; ++i){
        if(a[i] < a[i + 1]){
            ok = false;
            break;
        }
    }

    cout << (ok ? "DA\n" : "NE\n");
}

pair<int, int> valInd[N];
map<pair<int, int>, bool> open;

void s2Help(){
    pair<int, int> one = {0, 0};
    for(int i = 0; i < n; ++i){
        for(int j = 0; j < m; ++j){
            if(mat[i][j] == 1){
                one = {i, j};
            }
        }
    }
    open.clear();
    open[one] = true;

    bool ok = true;
    for(int i = 1; i <= n * m; ++i){
        if(open.count(valInd[i]) && open[valInd[i]]){
            auto x = valInd[i];
            open[{x.first - 1, x.second}] = true;
            open[{x.first + 1, x.second}] = true;
            open[{x.first, x.second - 1}] = true;
            open[{x.first, x.second + 1}] = true;
        }else{
            ok = false;
            break;
        }
    }

    if(ok){
        cout << "DA\n";
    }else{
        cout << "NE\n";
    }
}

void solve2(){
    s2Help();
    while(q--){
        int x1, y2, x2, y1;
        cin >> x1 >> y1 >> x2 >> y2; --y1; --y2; --x1; --x2;
        swap(mat[x1][y1], mat[x2][y2]);
        valInd[mat[x1][y1]] = {x1, y1};
        valInd[mat[x2][y2]] = {x2, y2};

        s2Help();
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> m >> q;
    mat.resize(n);
    for(int i = 0; i < n; ++i){
        mat[i].resize(m);
        for(int j = 0; j < m; ++j){
            cin >> mat[i][j];
            valInd[mat[i][j]] = {i, j};
        }
    }

    if(n != 1){
        solve2();
        return 0;
    }


    for(int i = 0; i < m; ++i){
        a[i] = mat[0][i];
        if(a[i] == 1)
            one = i;
    }

    for(int i = 0; i < m - 1; ++i){
        inv[i][0] = (a[i] < a[i + 1] ? 1 : 0);
        inv[i][1] = 1 - inv[i][0];
    }
    build(0, 0, m - 2);
    getQuery();
    //bruteforce();

    while(q--){
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2; --x1; --y1; --x2; --y2;
        swap(a[y1], a[y2]);

        updateQuery(y1, y2);
        //bruteforce();

        getQuery();
    }
    return 0;
}

/*
1 4 5
1 2 3 4
1 1 1 4
1 2 1 3
1 2 1 4
1 2 1 3
1 1 1 4
*/