#include <stdlib.h>
#include <stdio.h>
#include <map>
using namespace std;

void Qswap (long long* a, long long* b, long x, long y)
{
    long long t;

    t = a[x];
    a[x] = a[y];
    a[y] = t;

    t = b[x];
    b[x] = b[y];
    b[y] = t;
}

void Qsort (long long* a, long long* b, long l, long h)
{
    if (l<h)
    {
        long i = l-1;
        for (long j=l; j<h; j++)
            if (b[j]<b[h])
            {
                i++;
                Qswap (a, b, i, j);
            }
        i++;
        Qswap (a, b, i, h);

        Qsort (a, b, l, i-1);
        Qsort (a, b, i+1, h);
    }
}

long findW (long long* a, long x, long l, long h)
{
    if (l>=h)
        return h;
    else
    {
        long t = l+(h-l)/2;

        if (a[t]>=a[x] && (t==l || a[t-1]<a[x]))
            return t;
        else if (a[t]>=a[x])
            return findW (a, x, l, t-1);
        else
            return findW (a, x, t+1, h);
    }
}

int main()
{
    long N;
    scanf ("%ld", &N);

    long long* a = (long long*) malloc(N*sizeof(long long));
    long long* b = (long long*) malloc(N*sizeof(long long));
    for (long i=0; i<N; i++)
        scanf ("%lld", &a[i]);

    for (long i=0; i<N; i++)
        scanf ("%lld", &b[i]);

    Qsort (a, b, 0, N-1);

    long res = 0;
    long m = N;

    if (N<=5000)
    {
        for (long i=N-1; i>-1; i--)
        {
            long f = i;
            for (long j=i-1; j>-1; j--)
                if (a[j]>=a[i])
                    f = j;
            if (f<m)
                m = f;

            if (m == i)
                res++;
        }
    }
    else
    {
        for (long i=N-1; i>-1; i--)
        {
            long f = findW (a, i, 0, i);
            if (f<m)
                m = f;

            if (m == i)
                res++;
        }
    }


    printf ("%ld", res);

    return 0;
}