#include <stdlib.h>
#include <stdio.h>

int check (long** T, long x, long y, long N, long M)
{
    int res = 0;
    for (long i=x-1; i<=x+1; i++)
    {
        if (i<0 || i>N-1)
            continue;
        for (long j=y-1; j<=y+1; j++)
        {
            if (j<0 || j>M-1)
                continue;
            if (abs(x-i)+abs(y-j)>1)
                continue;
            if (T[i][j]<T[x][y])
                res = 1;
        }
    }
    return res;
}

long upd (long** T, int* C, long x, long y, long N, long M)
{
    long res = 0;

    for (long i=x-1; i<=x+1; i++)
    {
        if (i<0 || i>N-1)
            continue;
        for (long j=y-1; j<=y+1; j++)
        {
            if (j<0 || j>M-1)
                continue;
            if (abs(x-i)+abs(y-j)>1)
                continue;

            int temp = C[T[i][j]];
            C[T[i][j]] = check (T, i, j, N, M);
            res += C[T[i][j]] - temp;
        }
    }

    return res;
}

void print_pos (long cnt)
{
    if (cnt>0)
        printf ("NE\n");
    else
        printf ("DA\n");
}

int main()
{
    long N, M, Q;
    scanf ("%ld%ld%ld", &N, &M, &Q);

    long** T = (long**) malloc (N*sizeof( long*));
    for (long i=0; i<N; i++)
        T[i] = (long*) malloc (M*sizeof (long));
    for (long i=0; i<N; i++)
        for (long j=0; j<M; j++)
            scanf ("%ld", &T[i][j]);

    int* C = (int*) malloc ((N*M+1)*sizeof (int));
    long cnt = 0;

    for (long i=0; i<N; i++)
        for (long j=0; j<M; j++)
        {
            C[T[i][j]] = check (T, i, j, N, M);
            if (T[i][j]>1 && C[T[i][j]]==0)
                cnt++;
        }

    print_pos (cnt);

    long xa, ya, xb, yb;

    while (Q--)
    {
        scanf ("%ld%ld%ld%ld", &xa, &ya, &xb, &yb);
        xa--;
        xb--;
        ya--;
        yb--;

        long tem = T[xa][ya];
        T[xa][ya] = T[xb][yb];
        T[xb][yb] = tem;

        cnt -= upd (T, C, xa, ya, N, M);
        cnt -= upd (T, C, xb, yb, N, M);

        print_pos (cnt);
    }

    return 0;
}