#include <iostream>
#include <string>
#include <algorithm>
#include <utility>
#include <vector>
using namespace std;
using ll = int64_t;

void dfs(int s, int p, vector<ll>& sbt, vector<vector<int>>& g, vector<ll>& a){
    sbt[s] = a[s];
    for(int e : g[s]){
        if(e != p){
            dfs(e, s, sbt, g, a);
            sbt[s] += sbt[e];
        }
    }
}

void dfsl(int s, int p, vector<ll>& sbt, vector<vector<int>>& g, vector<ll>& k){
    for(int e : g[s]){
        k[e] = sbt[e] + sbt[s];
        dfsl(e, s, sbt, g, k);
    }
}

void solve(){
    int n; 
    cin >> n;
    vector<ll> a(n+1);
    for(int i=1; i<=n; ++i) cin >> a[i];

    vector<vector<int>> g(n+1);
    vector<int> h(n+1);
    int u;
    for(int i=0; i<n-1; ++i){
        cin >> u;
        g[u].push_back(i+2);
        g[i+2].push_back(u);
        h[i+2] = u;
    }

    ll s=0;
    for(int i=0; i<n; ++i) s += a[i];
    if(s != 0) cout << "-1\n";

    vector<ll> sbt(n+1);
    dfs(1, 0, sbt, g, a);
    vector<ll> k(n+1);
    k[1] = 0;
    dfsl(1, 0, sbt, g, k);
    for(int i=1; i<=n; ++i) cout << k[i] << ' ';
    cout << '\n';
}

int main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    solve();
}