#include <iostream>
#include <string>
#include <algorithm>
#include <utility>
#include <vector>
using namespace std;
#define ll long long

void dfs(int s, int p, vector<ll>& sbt, vector<vector<int> >& g, vector<ll>& a){
    sbt[s] = a[s];
    for(int i=0; i<(int)g[s].size(); ++i){
        int e = g[s][i];
        if(e != p){
            dfs(e, s, sbt, g, a);
            sbt[s] += sbt[e];
        }
    }
}

void dfsl(int s, int p, vector<ll>& sbt, vector<vector<int> >& g, vector<ll>& k){
    for(int i=0; i<(int)g[s].size(); ++i){
        int e = g[s][i];
        if(e != p){
            k[e] = sbt[e] + sbt[s];
            dfsl(e, s, sbt, g, k);
        }
    }
}

void solve(){
    int n;
    cin >> n;
    vector<ll> a(n+1);
    for(int i=1; i<=n; ++i) cin >> a[i];

    vector<vector<int> > g(n+1);
    vector<int> h(n+1);
    int u;
    for(int i=2; i<=n; ++i){
        cin >> u;
        g[u].push_back(i);
        g[i].push_back(u);
        h[i] = u;
    }

    //debug
    //for(int i=1; i<=n; ++i){
      //  cout << i << ": ";
        //for(int j=0; j<g[i].size(); ++j){
          //  cout << g[i][j] << ' ';
        //}
        //cout << '\n';
    //}
    //return;
    //print graph

    vector<ll> sbt(n+1);
    dfs(1, 0, sbt, g, a);
    if(sbt[1] != 0){
        cout << "-1\n";
        return;
    }
    vector<ll> k(n+1);
    k[1] = 0;
    dfsl(1, 0, sbt, g, k);
    for(int i=1; i<=n; ++i) cout << k[i] << ' ';
    cout << '\n';
}

int main(){
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    solve();
}