#include <algorithm>
#include <iostream>
#include <vector>
#include <queue>
#include <map>
using namespace std;
typedef long long ll;

ll mod = 1e9 + 7;
ll gcd(ll a, ll b)
{
	if (b == 0)
		return a;
	return gcd(b, a % b);
}

ll fact(ll n)
{
	ll f = 1;
	for (int i = 2; i <= n; i++)
	{
		f *= i;
		f %= mod;
	}
	return f;
}

ll brutus(vector<ll> e)
{
	ll multiply = 1;
	map<int, int> cnt_of_number;
	for (size_t i = 0; i < e.size(); i++)
		cnt_of_number[e[i]]++;
	for (auto kvp: cnt_of_number)
	{
		multiply *= fact(kvp.second);
	}

	ll sum = 0;
	sort(e.begin(), e.end());
	do
	{
		ll perm_sum = 0;
		for (int i = 0; i < e.size()-1; i++)
		{
			perm_sum += gcd(e[i], e[i + 1]);
			perm_sum %= mod;
		}
		perm_sum *= multiply;
		sum += perm_sum % mod;
		sum %= mod;
	} while (next_permutation(e.begin(),e.end()));
	return sum;
}

ll second_subtask(const vector<ll> elements)
{
	int n = elements.size();
	ll sol = 0;
	ll multiply = fact(n - 1) * 2;
	multiply %= mod;
	for (int i = 0; i < n; i++)
	{
		for (int j = i+1; j < n; j++)
		{
			sol += gcd(elements[i], elements[j]) * multiply;
			sol %= mod;
		}
	}
	return sol;
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);
	int n; cin >> n;
	vector<ll> elements(n);
	for (size_t i = 0; i < n; i++)
		cin >> elements[i];
	
	cout << second_subtask(elements);
	
	return 0;
}