#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>

#define fi first
#define se second
#define pb push_back
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ff(i,a,b) for(int i=a;i<=b;i++)
#define fb(i,b,a) for(int i=b;i>=a;i--)

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair<int,int> pii;
const int maxn = 300005;
const int inf = 1e9 + 5;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

// os.order_of_key(k) 
// *os.find_by_order(k)

int n;
pii niz[maxn];

int par[maxn], sz[maxn];
int findpar(int x){
	return (par[x] == x ? x : par[x] = findpar(par[x]));
}

void unite(int x, int y){
	x = findpar(x);
	y = findpar(y);
	if(x == y)return;
	if(sz[x] < sz[y])swap(x, y);
	par[y] = x;
	sz[x] += sz[y];
}

void init(){
	ff(i,1,n){
		par[i] = i;
		sz[i] = 1;
	}
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cin >> n;
	ff(i,1,n)cin >> niz[i].fi;
	ff(i,1,n)cin >> niz[i].se;
	sort(niz + 1, niz + n + 1);	
	
	init();
	
	fb(i,n,1){
		int X = niz[i].se;
	
		int mx = 0;		
		ff(j,i,n){
			if(niz[j].se < X)mx = j; 
		}
		
		if(mx != 0)unite(mx, i);
		
	}
		
	stack<int> stek;
	fb(i,n,1){
		while(!stek.empty() && niz[stek.top()].se < niz[i].se){
			unite(stek.top(), i);
			stek.pop();
		}
		stek.push(i);
	}
	
	int rez = 0;
	ff(i,1,n)rez += findpar(i) == i;
	cout << rez << endl;
	
	return 0;
}
/*

7
1 2 3 4 5 6 7 
5 1 7 3 4 2 6 


5
1 2 3 4 5 
3 1 5 4 2 


4
1 3 7 9
7 1 2 8

*/