#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#include <bits/stdc++.h>

#define fi first
#define se second
#define pb push_back
#define sz(a) (int)a.size()
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ff(i,a,b) for(int i=a;i<=b;i++)
#define fb(i,b,a) for(int i=b;i>=a;i--)

using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
typedef pair<int,int> pii;
const int maxn = 300005;
const int inf = 1e9 + 5;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

// os.order_of_key(k) 
// *os.find_by_order(k)

int n;
pii niz[maxn];

int par[maxn], sz[maxn];
int findpar(int x){
	return (par[x] == x ? x : par[x] = findpar(par[x]));
}

void unite(int x, int y){
	x = findpar(x);
	y = findpar(y);
	if(x == y)return;
	if(sz[x] < sz[y])swap(x, y);
	par[y] = x;
	sz[x] += sz[y];
}

void init(){
	ff(i,1,n){
		par[i] = i;
		sz[i] = 1;
	}
}

int bor[4 * maxn];
void update(int v, int tl, int tr, int pos, int val){
	if(tl == tr){
		bor[v] = val;
		return;
	}
	int mid = (tl + tr) / 2;
	if(pos <= mid)update(v * 2, tl, mid, pos, val);
	else update(v * 2 + 1, mid + 1, tr, pos, val);
	bor[v] = max(bor[v * 2], bor[v * 2 + 1]);
}

int kveri(int v, int tl, int tr, int l, int r){
	if(tl > r || l > tr)return 0;
	if(tl >= l && tr <= r)return bor[v];
	int mid = (tl + tr) / 2;
	return max(kveri(v * 2, tl, mid, l, r), kveri(v * 2 + 1, mid + 1, tr, l, r));
}

int main()
{
	ios::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cin >> n;
	ff(i,1,n)cin >> niz[i].fi;
	ff(i,1,n)cin >> niz[i].se;
	sort(niz + 1, niz + n + 1);	
	
	vector<int> all;
	ff(i,1,n)all.pb(niz[i].se);
	sort(all(all)), all.erase(unique(all(all)), all.end());
	ff(i,1,n)niz[i].se = lower_bound(all(all), niz[i].se) - all.begin() + 1;
	
//	ff(i,1,n)cout << niz[i].se << " ";
//	cout << endl;
	
	init();
	
	fb(i,n,1){
		int X = niz[i].se;
	
		int mx = kveri(1,1,n,1,X);
		if(mx != 0)unite(mx, i);
		
		update(1,1,n,X,i);
		
//		cout << "mx: " << mx << endl;
		
		
	}
		
	stack<int> stek;
	fb(i,n,1){
		while(!stek.empty() && niz[stek.top()].se < niz[i].se){
			unite(stek.top(), i);
			stek.pop();
		}
		stek.push(i);
	}
	
	int rez = 0;
	ff(i,1,n)rez += findpar(i) == i;
	cout << rez << endl;
	
	return 0;
}
/*

7
1 2 3 4 5 6 7 
5 1 7 3 4 2 6 


5
1 2 3 4 5 
3 1 5 4 2 


4
1 3 7 9
7 1 2 8

*/